# sstream

Go to the documentation of this file.

    00001 // String based streams -*- C++ -*-
    00002
    00003 // Copyright (C) 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006
    00004 // Free Software Foundation, Inc.
    00005 //
    00006 // This file is part of the GNU ISO C++ Library.  This library is free
    00007 // software; you can redistribute it and/or modify it under the
    00008 // terms of the GNU General Public License as published by the
    00009 // Free Software Foundation; either version 2, or (at your option)
    00010 // any later version.
    00011
    00012 // This library is distributed in the hope that it will be useful,
    00013 // but WITHOUT ANY WARRANTY; without even the implied warranty of
    00014 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    00015 // GNU General Public License for more details.
    00016
    00017 // You should have received a copy of the GNU General Public License along
    00018 // with this library; see the file COPYING.  If not, write to the Free
    00019 // Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
    00020 // USA.
    00021
    00022 // As a special exception, you may use this file as part of a free software
    00023 // library without restriction.  Specifically, if other files instantiate
    00024 // templates or use macros or inline functions from this file, or you compile
    00025 // this file and link it with other files to produce an executable, this
    00026 // file does not by itself cause the resulting executable to be covered by
    00027 // the GNU General Public License.  This exception does not however
    00028 // invalidate any other reasons why the executable file might be covered by
    00029 // the GNU General Public License.
    00030
    00031 /** @file sstream
    00032  *  This is a Standard C++ Library header.
    00033  */
    00034
    00035 //
    00036 // ISO C++ 14882: 27.7  String-based streams
    00037 //
    00038
    00039 #ifndef _GLIBCXX_SSTREAM
    00040 #define _GLIBCXX_SSTREAM 1
    00041
    00042 #pragma GCC system_header
    00043
    00044 #include <istream>
    00045 #include <ostream>
    00046
    00047 _GLIBCXX_BEGIN_NAMESPACE(std)
    00048
    00049   // [27.7.1] template class basic_stringbuf
    00050   /**
    00051    *  @brief  The actual work of input and output (for std::string).
    00052    *
    00053    *  This class associates either or both of its input and output sequences
    00054    *  with a sequence of characters, which can be initialized from, or made
    00055    *  available as, a @c std::basic_string.  (Paraphrased from [27.7.1]/1.)
    00056    *
    00057    *  For this class, open modes (of type @c ios_base::openmode) have
    00058    *  @c in set if the input sequence can be read, and @c out set if the
    00059    *  output sequence can be written.
    00060   */
    00061   template<typename _CharT, typename _Traits, typename _Alloc>
    00062     class basic_stringbuf : public basic_streambuf<_CharT, _Traits>
    00063     {
    00064     public:
    00065       // Types:
    00066       typedef _CharT                    char_type;
    00067       typedef _Traits                   traits_type;
    00068       // _GLIBCXX_RESOLVE_LIB_DEFECTS
    00069       // 251. basic_stringbuf missing allocator_type
    00070       typedef _Alloc                        allocator_type;
    00071       typedef typename traits_type::int_type        int_type;
    00072       typedef typename traits_type::pos_type        pos_type;
    00073       typedef typename traits_type::off_type        off_type;
    00074
    00075       typedef basic_streambuf<char_type, traits_type>   __streambuf_type;
    00076       typedef basic_string<char_type, _Traits, _Alloc>  __string_type;
    00077       typedef typename __string_type::size_type     __size_type;
    00078
    00079     protected:
    00080       /**
    00081        *  @if maint
    00082        *  Place to stash in || out || in | out settings for current stringbuf.
    00083        *  @endif
    00084       */
    00085       ios_base::openmode    _M_mode;
    00086
    00087       // Data Members:
    00088       __string_type         _M_string;
    00089
    00090     public:
    00091       // Constructors:
    00092       /**
    00093        *  @brief  Starts with an empty string buffer.
    00094        *  @param  mode  Whether the buffer can read, or write, or both.
    00095        *
    00096        *  The default constructor initializes the parent class using its
    00097        *  own default ctor.
    00098       */
    00099       explicit
    00100       basic_stringbuf(ios_base::openmode __mode = ios_base::in | ios_base::out)
    00101       : __streambuf_type(), _M_mode(__mode), _M_string()
    00102       { }
    00103
    00104       /**
    00105        *  @brief  Starts with an existing string buffer.
    00106        *  @param  str  A string to copy as a starting buffer.
    00107        *  @param  mode  Whether the buffer can read, or write, or both.
    00108        *
    00109        *  This constructor initializes the parent class using its
    00110        *  own default ctor.
    00111       */
    00112       explicit
    00113       basic_stringbuf(const __string_type& __str,
    00114               ios_base::openmode __mode = ios_base::in | ios_base::out)
    00115       : __streambuf_type(), _M_mode(), _M_string(__str.data(), __str.size())
    00116       { _M_stringbuf_init(__mode); }
    00117
    00118       // Get and set:
    00119       /**
    00120        *  @brief  Copying out the string buffer.
    00121        *  @return  A copy of one of the underlying sequences.
    00122        *
    00123        *  "If the buffer is only created in input mode, the underlying
    00124        *  character sequence is equal to the input sequence; otherwise, it
    00125        *  is equal to the output sequence." [27.7.1.2]/1
    00126       */
    00127       __string_type
    00128       str() const
    00129       {
    00130     __string_type __ret;
    00131     if (this->pptr())
    00132       {
    00133         // The current egptr() may not be the actual string end.
    00134         if (this->pptr() > this->egptr())
    00135           __ret = __string_type(this->pbase(), this->pptr());
    00136         else
    00137           __ret = __string_type(this->pbase(), this->egptr());
    00138       }
    00139     else
    00140       __ret = _M_string;
    00141     return __ret;
    00142       }
    00143
    00144       /**
    00145        *  @brief  Setting a new buffer.
    00146        *  @param  s  The string to use as a new sequence.
    00147        *
    00148        *  Deallocates any previous stored sequence, then copies @a s to
    00149        *  use as a new one.
    00150       */
    00151       void
    00152       str(const __string_type& __s)
    00153       {
    00154     // Cannot use _M_string = __s, since v3 strings are COW.
    00155     _M_string.assign(__s.data(), __s.size());
    00156     _M_stringbuf_init(_M_mode);
    00157       }
    00158
    00159     protected:
    00160       // Common initialization code goes here.
    00161       void
    00162       _M_stringbuf_init(ios_base::openmode __mode)
    00163       {
    00164     _M_mode = __mode;
    00165     __size_type __len = 0;
    00166     if (_M_mode & (ios_base::ate | ios_base::app))
    00167       __len = _M_string.size();
    00168     _M_sync(const_cast<char_type*>(_M_string.data()), 0, __len);
    00169       }
    00170
    00171       virtual streamsize
    00172       showmanyc()
    00173       {
    00174     streamsize __ret = -1;
    00175     if (_M_mode & ios_base::in)
    00176       {
    00177         _M_update_egptr();
    00178         __ret = this->egptr() - this->gptr();
    00179       }
    00180     return __ret;
    00181       }
    00182
    00183       virtual int_type
    00184       underflow();
    00185
    00186       virtual int_type
    00187       pbackfail(int_type __c = traits_type::eof());
    00188
    00189       virtual int_type
    00190       overflow(int_type __c = traits_type::eof());
    00191
    00192       /**
    00193        *  @brief  Manipulates the buffer.
    00194        *  @param  s  Pointer to a buffer area.
    00195        *  @param  n  Size of @a s.
    00196        *  @return  @c this
    00197        *
    00198        *  If no buffer has already been created, and both @a s and @a n are
    00199        *  non-zero, then @c s is used as a buffer; see
    00200        *  http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2
    00201        *  for more.
    00202       */
    00203       virtual __streambuf_type*
    00204       setbuf(char_type* __s, streamsize __n)
    00205       {
    00206     if (__s && __n >= 0)
    00207       {
    00208         // This is implementation-defined behavior, and assumes
    00209         // that an external char_type array of length __n exists
    00210         // and has been pre-allocated. If this is not the case,
    00211         // things will quickly blow up.
    00212
    00213         // Step 1: Destroy the current internal array.
    00214         _M_string.clear();
    00215
    00216         // Step 2: Use the external array.
    00217         _M_sync(__s, __n, 0);
    00218       }
    00219     return this;
    00220       }
    00221
    00222       virtual pos_type
    00223       seekoff(off_type __off, ios_base::seekdir __way,
    00224           ios_base::openmode __mode = ios_base::in | ios_base::out);
    00225
    00226       virtual pos_type
    00227       seekpos(pos_type __sp,
    00228           ios_base::openmode __mode = ios_base::in | ios_base::out);
    00229
    00230       // Internal function for correctly updating the internal buffer
    00231       // for a particular _M_string, due to initialization or re-sizing
    00232       // of an existing _M_string.
    00233       void
    00234       _M_sync(char_type* __base, __size_type __i, __size_type __o);
    00235
    00236       // Internal function for correctly updating egptr() to the actual
    00237       // string end.
    00238       void
    00239       _M_update_egptr()
    00240       {
    00241     const bool __testin = _M_mode & ios_base::in;
    00242     if (this->pptr() && this->pptr() > this->egptr())
    00243       if (__testin)
    00244         this->setg(this->eback(), this->gptr(), this->pptr());
    00245       else
    00246         this->setg(this->pptr(), this->pptr(), this->pptr());
    00247       }
    00248     };
    00249
    00250
    00251   // [27.7.2] Template class basic_istringstream
    00252   /**
    00253    *  @brief  Controlling input for std::string.
    00254    *
    00255    *  This class supports reading from objects of type std::basic_string,
    00256    *  using the inherited functions from std::basic_istream.  To control
    00257    *  the associated sequence, an instance of std::basic_stringbuf is used,
    00258    *  which this page refers to as @c sb.
    00259   */
    00260   template<typename _CharT, typename _Traits, typename _Alloc>
    00261     class basic_istringstream : public basic_istream<_CharT, _Traits>
    00262     {
    00263     public:
    00264       // Types:
    00265       typedef _CharT                    char_type;
    00266       typedef _Traits                   traits_type;
    00267       // _GLIBCXX_RESOLVE_LIB_DEFECTS
    00268       // 251. basic_stringbuf missing allocator_type
    00269       typedef _Alloc                        allocator_type;
    00270       typedef typename traits_type::int_type        int_type;
    00271       typedef typename traits_type::pos_type        pos_type;
    00272       typedef typename traits_type::off_type        off_type;
    00273
    00274       // Non-standard types:
    00275       typedef basic_string<_CharT, _Traits, _Alloc>     __string_type;
    00276       typedef basic_stringbuf<_CharT, _Traits, _Alloc>  __stringbuf_type;
    00277       typedef basic_istream<char_type, traits_type> __istream_type;
    00278
    00279     private:
    00280       __stringbuf_type  _M_stringbuf;
    00281
    00282     public:
    00283       // Constructors:
    00284       /**
    00285        *  @brief  Default constructor starts with an empty string buffer.
    00286        *  @param  mode  Whether the buffer can read, or write, or both.
    00287        *
    00288        *  @c ios_base::in is automatically included in @a mode.
    00289        *
    00290        *  Initializes @c sb using @c mode|in, and passes @c &sb to the base
    00291        *  class initializer.  Does not allocate any buffer.
    00292        *
    00293        *  @if maint
    00294        *  That's a lie.  We initialize the base class with NULL, because the
    00295        *  string class does its own memory management.
    00296        *  @endif
    00297       */
    00298       explicit
    00299       basic_istringstream(ios_base::openmode __mode = ios_base::in)
    00300       : __istream_type(), _M_stringbuf(__mode | ios_base::in)
    00301       { this->init(&_M_stringbuf); }
    00302
    00303       /**
    00304        *  @brief  Starts with an existing string buffer.
    00305        *  @param  str  A string to copy as a starting buffer.
    00306        *  @param  mode  Whether the buffer can read, or write, or both.
    00307        *
    00308        *  @c ios_base::in is automatically included in @a mode.
    00309        *
    00310        *  Initializes @c sb using @a str and @c mode|in, and passes @c &sb
    00311        *  to the base class initializer.
    00312        *
    00313        *  @if maint
    00314        *  That's a lie.  We initialize the base class with NULL, because the
    00315        *  string class does its own memory management.
    00316        *  @endif
    00317       */
    00318       explicit
    00319       basic_istringstream(const __string_type& __str,
    00320               ios_base::openmode __mode = ios_base::in)
    00321       : __istream_type(), _M_stringbuf(__str, __mode | ios_base::in)
    00322       { this->init(&_M_stringbuf); }
    00323
    00324       /**
    00325        *  @brief  The destructor does nothing.
    00326        *
    00327        *  The buffer is deallocated by the stringbuf object, not the
    00328        *  formatting stream.
    00329       */
    00330       ~basic_istringstream()
    00331       { }
    00332
    00333       // Members:
    00334       /**
    00335        *  @brief  Accessing the underlying buffer.
    00336        *  @return  The current basic_stringbuf buffer.
    00337        *
    00338        *  This hides both signatures of std::basic_ios::rdbuf().
    00339       */
    00340       __stringbuf_type*
    00341       rdbuf() const
    00342       { return const_cast<__stringbuf_type*>(&_M_stringbuf); }
    00343
    00344       /**
    00345        *  @brief  Copying out the string buffer.
    00346        *  @return  @c rdbuf()->str()
    00347       */
    00348       __string_type
    00349       str() const
    00350       { return _M_stringbuf.str(); }
    00351
    00352       /**
    00353        *  @brief  Setting a new buffer.
    00354        *  @param  s  The string to use as a new sequence.
    00355        *
    00356        *  Calls @c rdbuf()->str(s).
    00357       */
    00358       void
    00359       str(const __string_type& __s)
    00360       { _M_stringbuf.str(__s); }
    00361     };
    00362
    00363
    00364   // [27.7.3] Template class basic_ostringstream
    00365   /**
    00366    *  @brief  Controlling output for std::string.
    00367    *
    00368    *  This class supports writing to objects of type std::basic_string,
    00369    *  using the inherited functions from std::basic_ostream.  To control
    00370    *  the associated sequence, an instance of std::basic_stringbuf is used,
    00371    *  which this page refers to as @c sb.
    00372   */
    00373   template <typename _CharT, typename _Traits, typename _Alloc>
    00374     class basic_ostringstream : public basic_ostream<_CharT, _Traits>
    00375     {
    00376     public:
    00377       // Types:
    00378       typedef _CharT                    char_type;
    00379       typedef _Traits                   traits_type;
    00380       // _GLIBCXX_RESOLVE_LIB_DEFECTS
    00381       // 251. basic_stringbuf missing allocator_type
    00382       typedef _Alloc                        allocator_type;
    00383       typedef typename traits_type::int_type        int_type;
    00384       typedef typename traits_type::pos_type        pos_type;
    00385       typedef typename traits_type::off_type        off_type;
    00386
    00387       // Non-standard types:
    00388       typedef basic_string<_CharT, _Traits, _Alloc>     __string_type;
    00389       typedef basic_stringbuf<_CharT, _Traits, _Alloc>  __stringbuf_type;
    00390       typedef basic_ostream<char_type, traits_type> __ostream_type;
    00391
    00392     private:
    00393       __stringbuf_type  _M_stringbuf;
    00394
    00395     public:
    00396       // Constructors/destructor:
    00397       /**
    00398        *  @brief  Default constructor starts with an empty string buffer.
    00399        *  @param  mode  Whether the buffer can read, or write, or both.
    00400        *
    00401        *  @c ios_base::out is automatically included in @a mode.
    00402        *
    00403        *  Initializes @c sb using @c mode|out, and passes @c &sb to the base
    00404        *  class initializer.  Does not allocate any buffer.
    00405        *
    00406        *  @if maint
    00407        *  That's a lie.  We initialize the base class with NULL, because the
    00408        *  string class does its own memory management.
    00409        *  @endif
    00410       */
    00411       explicit
    00412       basic_ostringstream(ios_base::openmode __mode = ios_base::out)
    00413       : __ostream_type(), _M_stringbuf(__mode | ios_base::out)
    00414       { this->init(&_M_stringbuf); }
    00415
    00416       /**
    00417        *  @brief  Starts with an existing string buffer.
    00418        *  @param  str  A string to copy as a starting buffer.
    00419        *  @param  mode  Whether the buffer can read, or write, or both.
    00420        *
    00421        *  @c ios_base::out is automatically included in @a mode.
    00422        *
    00423        *  Initializes @c sb using @a str and @c mode|out, and passes @c &sb
    00424        *  to the base class initializer.
    00425        *
    00426        *  @if maint
    00427        *  That's a lie.  We initialize the base class with NULL, because the
    00428        *  string class does its own memory management.
    00429        *  @endif
    00430       */
    00431       explicit
    00432       basic_ostringstream(const __string_type& __str,
    00433               ios_base::openmode __mode = ios_base::out)
    00434       : __ostream_type(), _M_stringbuf(__str, __mode | ios_base::out)
    00435       { this->init(&_M_stringbuf); }
    00436
    00437       /**
    00438        *  @brief  The destructor does nothing.
    00439        *
    00440        *  The buffer is deallocated by the stringbuf object, not the
    00441        *  formatting stream.
    00442       */
    00443       ~basic_ostringstream()
    00444       { }
    00445
    00446       // Members:
    00447       /**
    00448        *  @brief  Accessing the underlying buffer.
    00449        *  @return  The current basic_stringbuf buffer.
    00450        *
    00451        *  This hides both signatures of std::basic_ios::rdbuf().
    00452       */
    00453       __stringbuf_type*
    00454       rdbuf() const
    00455       { return const_cast<__stringbuf_type*>(&_M_stringbuf); }
    00456
    00457       /**
    00458        *  @brief  Copying out the string buffer.
    00459        *  @return  @c rdbuf()->str()
    00460       */
    00461       __string_type
    00462       str() const
    00463       { return _M_stringbuf.str(); }
    00464
    00465       /**
    00466        *  @brief  Setting a new buffer.
    00467        *  @param  s  The string to use as a new sequence.
    00468        *
    00469        *  Calls @c rdbuf()->str(s).
    00470       */
    00471       void
    00472       str(const __string_type& __s)
    00473       { _M_stringbuf.str(__s); }
    00474     };
    00475
    00476
    00477   // [27.7.4] Template class basic_stringstream
    00478   /**
    00479    *  @brief  Controlling input and output for std::string.
    00480    *
    00481    *  This class supports reading from and writing to objects of type
    00482    *  std::basic_string, using the inherited functions from
    00483    *  std::basic_iostream.  To control the associated sequence, an instance
    00484    *  of std::basic_stringbuf is used, which this page refers to as @c sb.
    00485   */
    00486   template <typename _CharT, typename _Traits, typename _Alloc>
    00487     class basic_stringstream : public basic_iostream<_CharT, _Traits>
    00488     {
    00489     public:
    00490       // Types:
    00491       typedef _CharT                    char_type;
    00492       typedef _Traits                   traits_type;
    00493       // _GLIBCXX_RESOLVE_LIB_DEFECTS
    00494       // 251. basic_stringbuf missing allocator_type
    00495       typedef _Alloc                        allocator_type;
    00496       typedef typename traits_type::int_type        int_type;
    00497       typedef typename traits_type::pos_type        pos_type;
    00498       typedef typename traits_type::off_type        off_type;
    00499
    00500       // Non-standard Types:
    00501       typedef basic_string<_CharT, _Traits, _Alloc>     __string_type;
    00502       typedef basic_stringbuf<_CharT, _Traits, _Alloc>  __stringbuf_type;
    00503       typedef basic_iostream<char_type, traits_type>    __iostream_type;
    00504
    00505     private:
    00506       __stringbuf_type  _M_stringbuf;
    00507
    00508     public:
    00509       // Constructors/destructors
    00510       /**
    00511        *  @brief  Default constructor starts with an empty string buffer.
    00512        *  @param  mode  Whether the buffer can read, or write, or both.
    00513        *
    00514        *  Initializes @c sb using @c mode, and passes @c &sb to the base
    00515        *  class initializer.  Does not allocate any buffer.
    00516        *
    00517        *  @if maint
    00518        *  That's a lie.  We initialize the base class with NULL, because the
    00519        *  string class does its own memory management.
    00520        *  @endif
    00521       */
    00522       explicit
    00523       basic_stringstream(ios_base::openmode __m = ios_base::out | ios_base::in)
    00524       : __iostream_type(), _M_stringbuf(__m)
    00525       { this->init(&_M_stringbuf); }
    00526
    00527       /**
    00528        *  @brief  Starts with an existing string buffer.
    00529        *  @param  str  A string to copy as a starting buffer.
    00530        *  @param  mode  Whether the buffer can read, or write, or both.
    00531        *
    00532        *  Initializes @c sb using @a str and @c mode, and passes @c &sb
    00533        *  to the base class initializer.
    00534        *
    00535        *  @if maint
    00536        *  That's a lie.  We initialize the base class with NULL, because the
    00537        *  string class does its own memory management.
    00538        *  @endif
    00539       */
    00540       explicit
    00541       basic_stringstream(const __string_type& __str,
    00542              ios_base::openmode __m = ios_base::out | ios_base::in)
    00543       : __iostream_type(), _M_stringbuf(__str, __m)
    00544       { this->init(&_M_stringbuf); }
    00545
    00546       /**
    00547        *  @brief  The destructor does nothing.
    00548        *
    00549        *  The buffer is deallocated by the stringbuf object, not the
    00550        *  formatting stream.
    00551       */
    00552       ~basic_stringstream()
    00553       { }
    00554
    00555       // Members:
    00556       /**
    00557        *  @brief  Accessing the underlying buffer.
    00558        *  @return  The current basic_stringbuf buffer.
    00559        *
    00560        *  This hides both signatures of std::basic_ios::rdbuf().
    00561       */
    00562       __stringbuf_type*
    00563       rdbuf() const
    00564       { return const_cast<__stringbuf_type*>(&_M_stringbuf); }
    00565
    00566       /**
    00567        *  @brief  Copying out the string buffer.
    00568        *  @return  @c rdbuf()->str()
    00569       */
    00570       __string_type
    00571       str() const
    00572       { return _M_stringbuf.str(); }
    00573
    00574       /**
    00575        *  @brief  Setting a new buffer.
    00576        *  @param  s  The string to use as a new sequence.
    00577        *
    00578        *  Calls @c rdbuf()->str(s).
    00579       */
    00580       void
    00581       str(const __string_type& __s)
    00582       { _M_stringbuf.str(__s); }
    00583     };
    00584
    00585 _GLIBCXX_END_NAMESPACE
    00586
    00587 #ifndef _GLIBCXX_EXPORT_TEMPLATE
    00588 # include <bits/sstream.tcc>
    00589 #endif
    00590
    00591 #endif /* _GLIBCXX_SSTREAM */